from backend.elevationreader import ElevationReader
import pathlib

CURRENT_DIR = pathlib.Path(__file__).parent
DEFAULT_DIR = CURRENT_DIR / "testresources/adcircfiles"

"""
    This functions test the ADCIRC file reader for:
        - Reading input files and acquiring the data as expected.
        - Reading input files and acquiring the data from a specific record as expected.
        - Getting the desired for a single node. 
        - Getting all timesteps.
        - Getting the number of nodes of a single file.
        - Getting all surface elevation data across all recods.
        - Getting all surface elevation data given the timestep. 
"""


def test_read_file_elevations_firstvalues_fort():
    reader = ElevationReader(DEFAULT_DIR / "fort.63")
    res = reader.read_file()
    assert res[0][0:63] == [
        [1, 1.1450492637e-06],
        [2, -5.2667063897e-06],
        [3, 4.9732795952e-06],
        [4, -5.178849373e-05],
        [5, 5.4278443422e-05],
        [6, -0.0006256292592],
        [7, 0.0018434116472],
        [8, 2.7913218041e-06],
        [9, -1.7416319938e-06],
        [10, 1.5814443164e-05],
        [11, -1.4213065951e-05],
        [12, 0.00016948234371],
        [13, -4.4145014207e-05],
        [14, 0.0018434116472],
        [15, 1.1450516132e-06],
        [16, -5.2667110406e-06],
        [17, 4.973222374e-06],
        [18, -5.1788490139e-05],
        [19, 5.4278701467e-05],
        [20, -0.00062562857701],
        [21, 0.0018434116472],
        [22, 2.7913175488e-06],
        [23, -1.7416022309e-06],
        [24, 1.5814516272e-05],
        [25, -1.4212905499e-05],
        [26, 0.00016948124572],
        [27, -4.4140207114e-05],
        [28, 0.0018434116472],
        [29, 1.1450554071e-06],
        [30, -5.2666987898e-06],
        [31, 4.9732248269e-06],
        [32, -5.1788645921e-05],
        [33, 5.4277438459e-05],
        [34, -0.00062563139504],
        [35, 0.0018434116472],
        [36, 2.7913175488e-06],
        [37, -1.7416022309e-06],
        [38, 1.5814516272e-05],
        [39, -1.4212905499e-05],
        [40, 0.00016948124572],
        [41, -4.4140207114e-05],
        [42, 0.0018434116472],
        [43, 1.1450516132e-06],
        [44, -5.2667110406e-06],
        [45, 4.973222374e-06],
        [46, -5.1788490139e-05],
        [47, 5.4278701467e-05],
        [48, -0.00062562857701],
        [49, 0.0018434116472],
        [50, 2.7913218041e-06],
        [51, -1.7416319938e-06],
        [52, 1.5814443164e-05],
        [53, -1.4213065951e-05],
        [54, 0.00016948234371],
        [55, -4.4145014207e-05],
        [56, 0.0018434116472],
        [57, 1.1450492637e-06],
        [58, -5.2667063897e-06],
        [59, 4.9732795952e-06],
        [60, -5.178849373e-05],
        [61, 5.4278443422e-05],
        [62, -0.0006256292592],
        [63, 0.0018434116472],
    ]


def test_got_expected_records():
    reader = ElevationReader(DEFAULT_DIR / "fort.63")
    res = reader.read_num_of_records()
    assert res == 824


def test_got_unexpected_records():
    reader = ElevationReader(DEFAULT_DIR / "fort.63")
    res = reader.read_num_of_records()
    assert res != 823


def test_read_file_elevations_firstvalues_maxele():
    reader = ElevationReader(DEFAULT_DIR / "maxele1.63")
    res = reader.read_file()
    assert res[0][0:6] == [
        [1, 6.4565367111e-001],
        [2, 6.0358375526e-001],
        [3, 5.2790590959e-001],
        [4, 4.5939002518e-001],
        [5, 3.9914177666e-001],
        [6, 3.4661797854e-001],
    ]


def test_read_num_datasets_maxele():
    reader = ElevationReader(DEFAULT_DIR / "maxele1.63")
    res = reader.read_num_of_records()
    assert res == 2.0


def test_read_time_steps_fort():
    reader = ElevationReader(DEFAULT_DIR / "fort.63")
    res = reader.read_file()
    assert res[2] == [
        3,
        6,
        9,
        12,
        15,
        18,
        21,
        24,
        27,
        30,
        33,
        36,
        39,
        42,
        45,
        48,
        51,
        54,
        57,
        60,
        63,
        66,
        69,
        72,
        75,
        78,
        81,
        84,
        87,
        90,
        93,
        96,
        99,
        102,
        105,
        108,
        111,
        114,
        117,
        120,
        123,
        126,
        129,
        132,
        135,
        138,
        141,
        144,
        147,
        150,
        153,
        156,
        159,
        162,
        165,
        168,
        171,
        174,
        177,
        180,
        183,
        186,
        189,
        192,
        195,
        198,
        201,
        204,
        207,
        210,
        213,
        216,
        219,
        222,
        225,
        228,
        231,
        234,
        237,
        240,
        243,
        246,
        249,
        252,
        255,
        258,
        261,
        264,
        267,
        270,
        273,
        276,
        279,
        282,
        285,
        288,
        291,
        294,
        297,
        300,
        303,
        306,
        309,
        312,
        315,
        318,
        321,
        324,
        327,
        330,
        333,
        336,
        339,
        342,
        345,
        348,
        351,
        354,
        357,
        360,
        363,
        366,
        369,
        372,
        375,
        378,
        381,
        384,
        387,
        390,
        393,
        396,
        399,
        402,
        405,
        408,
        411,
        414,
        417,
        420,
        423,
        426,
        429,
        432,
        435,
        438,
        441,
        444,
        447,
        450,
        453,
        456,
        459,
        462,
        465,
        468,
        471,
        474,
        477,
        480,
        483,
        486,
        489,
        492,
        495,
        498,
        501,
        504,
        507,
        510,
        513,
        516,
        519,
        522,
        525,
        528,
        531,
        534,
        537,
        540,
        543,
        546,
        549,
        552,
        555,
        558,
        561,
        564,
        567,
        570,
        573,
        576,
        579,
        582,
        585,
        588,
        591,
        594,
        597,
        600,
        603,
        606,
        609,
        612,
        615,
        618,
        621,
        624,
        627,
        630,
        633,
        636,
        639,
        642,
        645,
        648,
        651,
        654,
        657,
        660,
        663,
        666,
        669,
        672,
        675,
        678,
        681,
        684,
        687,
        690,
        693,
        696,
        699,
        702,
        705,
        708,
        711,
        714,
        717,
        720,
        723,
        726,
        729,
        732,
        735,
        738,
        741,
        744,
        747,
        750,
        753,
        756,
        759,
        762,
        765,
        768,
        771,
        774,
        777,
        780,
        783,
        786,
        789,
        792,
        795,
        798,
        801,
        804,
        807,
        810,
        813,
        816,
        819,
        822,
        825,
        828,
        831,
        834,
        837,
        840,
        843,
        846,
        849,
        852,
        855,
        858,
        861,
        864,
        867,
        870,
        873,
        876,
        879,
        882,
        885,
        888,
        891,
        894,
        897,
        900,
        903,
        906,
        909,
        912,
        915,
        918,
        921,
        924,
        927,
        930,
        933,
        936,
        939,
        942,
        945,
        948,
        951,
        954,
        957,
        960,
        963,
        966,
        969,
        972,
        975,
        978,
        981,
        984,
        987,
        990,
        993,
        996,
        999,
        1002,
        1005,
        1008,
        1011,
        1014,
        1017,
        1020,
        1023,
        1026,
        1029,
        1032,
        1035,
        1038,
        1041,
        1044,
        1047,
        1050,
        1053,
        1056,
        1059,
        1062,
        1065,
        1068,
        1071,
        1074,
        1077,
        1080,
        1083,
        1086,
        1089,
        1092,
        1095,
        1098,
        1101,
        1104,
        1107,
        1110,
        1113,
        1116,
        1119,
        1122,
        1125,
        1128,
        1131,
        1134,
        1137,
        1140,
        1143,
        1146,
        1149,
        1152,
        1155,
        1158,
        1161,
        1164,
        1167,
        1170,
        1173,
        1176,
        1179,
        1182,
        1185,
        1188,
        1191,
        1194,
        1197,
        1200,
        1203,
        1206,
        1209,
        1212,
        1215,
        1218,
        1221,
        1224,
        1227,
        1230,
        1233,
        1236,
        1239,
        1242,
        1245,
        1248,
        1251,
        1254,
        1257,
        1260,
        1263,
        1266,
        1269,
        1272,
        1275,
        1278,
        1281,
        1284,
        1287,
        1290,
        1293,
        1296,
        1299,
        1302,
        1305,
        1308,
        1311,
        1314,
        1317,
        1320,
        1323,
        1326,
        1329,
        1332,
        1335,
        1338,
        1341,
        1344,
        1347,
        1350,
        1353,
        1356,
        1359,
        1362,
        1365,
        1368,
        1371,
        1374,
        1377,
        1380,
        1383,
        1386,
        1389,
        1392,
        1395,
        1398,
        1401,
        1404,
        1407,
        1410,
        1413,
        1416,
        1419,
        1422,
        1425,
        1428,
        1431,
        1434,
        1437,
        1440,
        1443,
        1446,
        1449,
        1452,
        1455,
        1458,
        1461,
        1464,
        1467,
        1470,
        1473,
        1476,
        1479,
        1482,
        1485,
        1488,
        1491,
        1494,
        1497,
        1500,
        1503,
        1506,
        1509,
        1512,
        1515,
        1518,
        1521,
        1524,
        1527,
        1530,
        1533,
        1536,
        1539,
        1542,
        1545,
        1548,
        1551,
        1554,
        1557,
        1560,
        1563,
        1566,
        1569,
        1572,
        1575,
        1578,
        1581,
        1584,
        1587,
        1590,
        1593,
        1596,
        1599,
        1602,
        1605,
        1608,
        1611,
        1614,
        1617,
        1620,
        1623,
        1626,
        1629,
        1632,
        1635,
        1638,
        1641,
        1644,
        1647,
        1650,
        1653,
        1656,
        1659,
        1662,
        1665,
        1668,
        1671,
        1674,
        1677,
        1680,
        1683,
        1686,
        1689,
        1692,
        1695,
        1698,
        1701,
        1704,
        1707,
        1710,
        1713,
        1716,
        1719,
        1722,
        1725,
        1728,
        1731,
        1734,
        1737,
        1740,
        1743,
        1746,
        1749,
        1752,
        1755,
        1758,
        1761,
        1764,
        1767,
        1770,
        1773,
        1776,
        1779,
        1782,
        1785,
        1788,
        1791,
        1794,
        1797,
        1800,
        1803,
        1806,
        1809,
        1812,
        1815,
        1818,
        1821,
        1824,
        1827,
        1830,
        1833,
        1836,
        1839,
        1842,
        1845,
        1848,
        1851,
        1854,
        1857,
        1860,
        1863,
        1866,
        1869,
        1872,
        1875,
        1878,
        1881,
        1884,
        1887,
        1890,
        1893,
        1896,
        1899,
        1902,
        1905,
        1908,
        1911,
        1914,
        1917,
        1920,
        1923,
        1926,
        1929,
        1932,
        1935,
        1938,
        1941,
        1944,
        1947,
        1950,
        1953,
        1956,
        1959,
        1962,
        1965,
        1968,
        1971,
        1974,
        1977,
        1980,
        1983,
        1986,
        1989,
        1992,
        1995,
        1998,
        2001,
        2004,
        2007,
        2010,
        2013,
        2016,
        2019,
        2022,
        2025,
        2028,
        2031,
        2034,
        2037,
        2040,
        2043,
        2046,
        2049,
        2052,
        2055,
        2058,
        2061,
        2064,
        2067,
        2070,
        2073,
        2076,
        2079,
        2082,
        2085,
        2088,
        2091,
        2094,
        2097,
        2100,
        2103,
        2106,
        2109,
        2112,
        2115,
        2118,
        2121,
        2124,
        2127,
        2130,
        2133,
        2136,
        2139,
        2142,
        2145,
        2148,
        2151,
        2154,
        2157,
        2160,
        2163,
        2166,
        2169,
        2172,
        2175,
        2178,
        2181,
        2184,
        2187,
        2190,
        2193,
        2196,
        2199,
        2202,
        2205,
        2208,
        2211,
        2214,
        2217,
        2220,
        2223,
        2226,
        2229,
        2232,
        2235,
        2238,
        2241,
        2244,
        2247,
        2250,
        2253,
        2256,
        2259,
        2262,
        2265,
        2268,
        2271,
        2274,
        2277,
        2280,
        2283,
        2286,
        2289,
        2292,
        2295,
        2298,
        2301,
        2304,
        2307,
        2310,
        2313,
        2316,
        2319,
        2322,
        2325,
        2328,
        2331,
        2334,
        2337,
        2340,
        2343,
        2346,
        2349,
        2352,
        2355,
        2358,
        2361,
        2364,
        2367,
        2370,
        2373,
        2376,
        2379,
        2382,
        2385,
        2388,
        2391,
        2394,
        2397,
        2400,
        2403,
        2406,
        2409,
        2412,
        2415,
        2418,
        2421,
        2424,
        2427,
        2430,
        2433,
        2436,
        2439,
        2442,
        2445,
        2448,
        2451,
        2454,
        2457,
        2460,
        2463,
        2466,
        2469,
        2472,
    ]


def test_read_time_steps_maxele():
    reader = ElevationReader(DEFAULT_DIR / "maxele1.63")
    res = reader.read_file()
    assert res[2] == [2473, 2473]


def test_read_node_number_maxele():
    reader = ElevationReader(DEFAULT_DIR / "maxele1.63")
    nodenumber = reader.read_num_of_nodes()
    assert nodenumber == 63


def test_read_file_corrupted_fort_but_read():
    reader = ElevationReader(DEFAULT_DIR / "corruptedfort.63")
    result = reader.read_file()
    lasttimestep = result[2][len(result[2]) - 1]
    firsttimestep = result[2][0]
    actualrecords = (
            lasttimestep // firsttimestep
    )  # last timestep / first timestep gives number of actual records
    expectedrecords = reader.read_num_of_records()
    assert actualrecords != expectedrecords


def test_read_file_fort64():
    reader = ElevationReader(DEFAULT_DIR / "fort.64")
    result = reader.read_file()
    assert result[0][0:63] == [[1, 0.0000000000E+000, 0.0000000000E+000], [2, -9.2467039072E-007, 0.0000000000E+000],
                               [3, 4.4288241853E-006, 0.0000000000E+000],
                               [4, -1.0483002852E-005, 0.0000000000E+000],
                               [5, 5.2763813375E-005, 0.0000000000E+000],
                               [6, -1.5448977604E-004, 0.0000000000E+000],
                               [7, -4.2666709706E-004, 0.0000000000E+000],
                               [8, 5.5222071338E-014, -2.7762172515E-013],
                               [9, -1.2256660318E-006, -2.4379586412E-007],
                               [10, 3.0250385124E-006, 6.0171638403E-007],
                               [11, -1.3930572888E-005, -2.7709557111E-006],
                               [12, 2.9570255280E-005, 5.8818109541E-006],
                               [13, -1.3720560616E-004, -2.7291619476E-005],
                               [14, -3.7090383231E-004, -7.3776789582E-005],
                               [15, -1.3074632706E-013, 3.1564817550E-013],
                               [16, -8.5428241553E-007, -3.5385807936E-007],
                               [17, 4.0917111392E-006, 1.6948440992E-006],
                               [18, -9.6849784833E-006, -4.0116466438E-006],
                               [19, 4.8747172813E-005, 2.0191737116E-005],
                               [20, -1.4273026362E-004, -5.9120981591E-005],
                               [21, -3.9419029134E-004, -1.6327944328E-004],
                               [22, 2.3106727841E-012, -3.4580881284E-012],
                               [23, -1.0390758078E-006, -6.9428920081E-007],
                               [24, 2.5645020706E-006, 1.7135647341E-006],
                               [25, -1.1809598259E-005, -7.8909891969E-006],
                               [26, 2.5068208982E-005, 1.6750156020E-005],
                               [27, -1.1631757597E-004, -7.7721506123E-005],
                               [28, -3.1443786224E-004, -2.1010222427E-004],
                               [29, 0.0000000000E+000, 0.0000000000E+000],
                               [30, -6.5383950309E-007, -6.5383950309E-007],
                               [31, 3.1316952190E-006, 3.1316952190E-006],
                               [32, -7.4124653135E-006, -7.4124653135E-006],
                               [33, 3.7309638120E-005, 3.7309638120E-005],
                               [34, -1.0924148369E-004, -1.0924148369E-004],
                               [35, -3.0169969860E-004, -3.0169969860E-004],
                               [36, -3.4580881282E-012, 2.3106727839E-012],
                               [37, -6.9428920081E-007, -1.0390758078E-006],
                               [38, 1.7135647341E-006, 2.5645020706E-006],
                               [39, -7.8909891969E-006, -1.1809598259E-005],
                               [40, 1.6750156020E-005, 2.5068208982E-005],
                               [41, -7.7721506123E-005, -1.1631757597E-004],
                               [42, -2.1010222427E-004, -3.1443786224E-004],
                               [43, 3.1564817560E-013, -1.3074632710E-013],
                               [44, -3.5385807936E-007, -8.5428241553E-007],
                               [45, 1.6948440992E-006, 4.0917111392E-006],
                               [46, -4.0116466438E-006, -9.6849784833E-006],
                               [47, 2.0191737116E-005, 4.8747172813E-005],
                               [48, -5.9120981591E-005, -1.4273026362E-004],
                               [49, -1.6327944328E-004, -3.9419029134E-004],
                               [50, -2.7762172550E-013, 5.5222071407E-014],
                               [51, -2.4379586412E-007, -1.2256660318E-006],
                               [52, 6.0171638403E-007, 3.0250385124E-006],
                               [53, -2.7709557111E-006, -1.3930572888E-005],
                               [54, 5.8818109541E-006, 2.9570255280E-005],
                               [55, -2.7291619476E-005, -1.3720560616E-004],
                               [56, -7.3776789582E-005, -3.7090383231E-004],
                               [57, 0.0000000000E+000, 0.0000000000E+000],
                               [58, 0.0000000000E+000, -9.2467039072E-007],
                               [59, 0.0000000000E+000, 4.4288241853E-006],
                               [60, 0.0000000000E+000, -1.0483002852E-005],
                               [61, 0.0000000000E+000, 5.2763813375E-005],
                               [62, 0.0000000000E+000, -1.5448977604E-004],
                               [63, 0.0000000000E+000, -4.2666709706E-004]]


def test_elevation_getter():
    reader = ElevationReader(DEFAULT_DIR / "maxele1.63")
    reader.read_file()
    surface_elevation = reader.get_surface_elevations_every_node()
    print(len(surface_elevation))
    assert surface_elevation[0:6] == [6.4565367111e-001, 6.0358375526e-001, 5.2790590959e-001,
                                      4.5939002518e-001, 3.9914177666e-001, 3.4661797854e-001, ]


# --------------------------------------------------------------------------------------------------------------------
"""
    These test that the object's function is able to get all the surface elevation
    values for a single desired node.
"""


def test_all_elevations_for_node():
    reader = ElevationReader(DEFAULT_DIR / "maxele1.63")
    reader.read_file()
    surface_elevation = reader.get_surface_elevations_every_node()
    valuesfornode = reader.get_all_elevations_for_node(1)
    assert valuesfornode == [6.4565367111E-001, 4.0555123200E+005]


def test_all_elevations_for_node2():
    reader = ElevationReader(DEFAULT_DIR / "maxele1.63")
    reader.read_file()
    surface_elevation = reader.get_surface_elevations_every_node()
    valuesfornode = reader.get_all_elevations_for_node(63)
    assert valuesfornode == [3.0474510070E-001, 4.0240742400E+005]


# --------------------------------------------------------------------------------------------------------------------

def test_all_values_for_timestep():
    reader = ElevationReader(DEFAULT_DIR / "maxele1.63")
    reader.read_file()
    values = reader.get_all_elevations_for_time(2473)
    assert values[0:6] == [6.4565367111e-001, 6.0358375526e-001, 5.2790590959e-001, 4.5939002518e-001,
                           3.9914177666e-001,
                           3.4661797854e-001]


def test_values_for_timestep_record6():
    reader = ElevationReader(DEFAULT_DIR / "fort.63")
    reader.read_file()
    values = reader.get_all_elevations_for_time(6)
    assert values[0:5] == [1.8344369143E-006, -8.4550778464E-006, 5.5897485050E-006, -7.4349417360E-005,
                           2.4576004222E-005]


def test_values_for_timestep_record9():
    reader = ElevationReader(DEFAULT_DIR / "fort.63")
    reader.read_file()
    values = reader.get_all_elevations_for_time(9)
    assert values[0:5] == [4.1952728874E-006, -1.8599135958E-005, 1.0521659043E-005, -1.2866034870E-004,
                           8.1371690149E-005]
